local T, C, L, _ = unpack(select(2, ...))
if C.trade.auto_buy ~= true then return end

--------------------------------------------------------------------------------------
--  Auto Buy
--------------------------------------------------------------------------------------
local function Buy()
    if IsShiftKeyDown() then return end
    for i = 0, GetMerchantNumItems() do
        if T.buy_list then
            for _, item in pairs(T.buy_list) do
                local itemID, quantity = item[1], item[2]
                local itemName, _, _, _, _, _, _, itemStackCount = GetItemInfo(itemID)
                local MerName, _, _, _, MerNumAvailable = GetMerchantItemInfo(i)

                local numOwned = GetItemCount(itemID)
                local numToBuy = quantity - numOwned

                if (numToBuy < 0) then numToBuy = 0 end
                if (itemName == MerName and numToBuy > 0 and itemName ~= nil and MerName ~= nil) then
                    if MerNumAvailable ~= -1 then numToBuy = min(MerNumAvailable, numToBuy) end
                    if (numToBuy > itemStackCount ) then
                        local remainder = numToBuy % itemStackCount;
                        local tempNum = numToBuy - remainder;
                        local stacks = tempNum / itemStackCount;
                        for j = 1, stacks do
                            BuyMerchantItem(i, itemStackCount)
                        end
                        if (remainder > 0) then BuyMerchantItem(i, remainder) end
                    else
                        BuyMerchantItem(i, numToBuy)
                    end
                end
            end
        end
    end
end

local BANK_BAGS_REVERSED = {-1, 5, 6, 7, 8, 9, 10, 11}
local function IsItemInList(item)
    for _, Item in ipairs(T.buy_list) do
        if Item[1] == item then
            return true
        end
    end
    return false
end

local function GetItemIndex(item)
    for i, Item in ipairs(T.buy_list) do
        if Item[1] == item then
            return i
        end
    end
    return nil
end

local function GetItemsInBags()
    local T = {}
    for bag = BACKPACK_CONTAINER, NUM_BAG_SLOTS do
        for slot = 1, GetContainerNumSlots(bag) do
            local _, itemCount, locked, _, _, _, itemLink, _, _, itemID = GetContainerItemInfo(bag, slot)
            if itemID then
                T[itemID] = T[itemID] and T[itemID] + itemCount or itemCount
            end
        end
    end
    return T
end

local function PutSplitItemIntoBags(item, amountOnMouse)
    if not CursorHasItem() then return end
    C_NewItems.ClearAll()

    for bag = BACKPACK_CONTAINER, NUM_BAG_SLOTS do
        for slot = 1, GetContainerNumSlots(bag) do
        local _, itemCount, locked, _, _, _, _, _, _, itemID = GetContainerItemInfo(bag, slot)
            if itemID and not locked then
            local itemStackCount = select(8, GetItemInfo(itemID))
                if itemID == item[1] and itemCount + amountOnMouse <= itemStackCount then
                    PickupContainerItem(bag, slot)
                end
            end
        end
    end

    for bag = BACKPACK_CONTAINER, NUM_BAG_SLOTS do
    local numberOfFreeSlots, bagType = GetContainerNumFreeSlots(bag)
        if numberOfFreeSlots > 0 then
        local currentBag = bag + 19
            if currentBag == 19 then
                PutItemInBackpack()
                return
            else
                PutItemInBag(currentBag)
                return
            end
        end
    end
end

local function BankTransfer()
	if IsShiftKeyDown() then return end
    local itemsInBags = GetItemsInBags()
    local currentProfile = T.buy_list
    local rightClickedItem = false
    local transferredToBank = false

    for bag = NUM_BAG_SLOTS, BACKPACK_CONTAINER, -1 do
        for slot = GetContainerNumSlots(bag), 1, -1 do
        local _, itemCount, locked, _, _, _, itemLink, _, _, itemID = GetContainerItemInfo(bag, slot)
            if itemID then
            local inList = IsItemInList(itemID)
                if not locked and inList then
                local item = currentProfile[GetItemIndex(itemID)]
                local numInBags = itemsInBags[item[1]] or 0
                local Num = item[2]
                local difference = Num - numInBags
                    if difference < 0 then
                        UseContainerItem(bag, slot)
                        itemsInBags[item[1]] = itemsInBags[item[1]] and itemsInBags[item[1]] - itemCount
                        rightClickedItem = true
                        transferredToBank = true
                    end
                end
            end
        end
    end

    if not transferredToBank then
        for _, bag in ipairs(BANK_BAGS_REVERSED) do
            for slot = GetContainerNumSlots(bag), 1, -1 do
            local _, itemCount, locked, _, _, _, itemLink, _, _, itemID = GetContainerItemInfo(bag, slot)
                if itemID and not locked then
                local inList = IsItemInList(itemID)
                    if not locked and inList then
                    local item = currentProfile[GetItemIndex(itemID)]
                    local numInBags = itemsInBags[item[1]] or 0
                    local Num = item[2]
                    local difference = Num - numInBags
                        if difference > 0 and itemCount <= difference then
                            UseContainerItem(bag, slot)
                            itemsInBags[item[1]] = itemsInBags[item[1]] and itemsInBags[item[1]] + itemCount or itemCount
                            rightClickedItem = true
                        end
                    end
                end
            end
        end
    end

    if not rightClickedItem then
        for _, bag in ipairs(BANK_BAGS_REVERSED) do
            for slot = GetContainerNumSlots(bag), 1, -1 do
            local _, itemCount, locked, _, _, _, itemLink, _, _, itemID = GetContainerItemInfo(bag, slot)
                if itemID and not locked then
                local inList = IsItemInList(itemID)
                local itemStackCount = select(8, GetItemInfo(itemID))
                    if inList then
                    local item = currentProfile[GetItemIndex(itemID)]
                    local numInBags = itemsInBags[item[1]] or 0
                    local Num = item[2]
                    local difference = Num-numInBags
                        if difference > 0 and itemCount > difference then
                            if mod(difference + numInBags, itemStackCount) == 0 then
                                PickupContainerItem(bag, slot)
                            else
                                SplitContainerItem(bag, slot, difference)
                            end
                            PutSplitItemIntoBags(item, difference)
                            itemsInBags[item[1]] = itemsInBags[item[1]] and itemsInBags[item[1]] + difference or difference
                        end
                    end
                end
             end
        end
    end
    if not (rightClickedItem == false and transferredToBank == false) then
       C_Timer.After(0.7, BankTransfer)
    end
end

local AutoBuy = CreateFrame("Frame")
AutoBuy:RegisterEvent("MERCHANT_SHOW")
AutoBuy:RegisterEvent("BANKFRAME_OPENED")
AutoBuy:SetScript("OnEvent", function(self, event)
    if event == "MERCHANT_SHOW" then
    	Buy()
    elseif event == "BANKFRAME_OPENED" then
        BankTransfer()
    end
end)
